#include "summa.hh"
#include "tulo.hh"
#include "yksikot.hh"

summa& summa::operator*= (elemp p)
{
	elemap nmap;
	for(elemap::iterator i = elems.begin(); i != elems.end(); ++i)
	{
		if(i->first->type == '*')
		{
			((tulo *)&*(i->first))->insert(p);
			nmap[i->first] += i->second;
		}
		else
		{
			tulop tmp = new tulo;
			tmp->insert(p);
			tmp->insert(i->first);
			nmap[&*tmp] += i->second;
		}
	}
	elems = nmap;
	return *this;
}

bool summa::operator== (const Elem &e) const
{
	if(type != e.type)return false;
	const summa &tmp = *(const summa *)&e;
	return lisays == tmp.lisays
	    && elems == tmp.elems;
}
bool summa::operator< (const Elem &e) const
{
	if(type < e.type)return true;
	if(type > e.type)return false;
	const summa &tmp = *(const summa *)&e;
	
	if(lisays < tmp.lisays)return true;
	if(lisays > tmp.lisays)return false;
	
	unsigned b=tmp.size();
	
	if(size() < b)return true;
	if(size() > b)return false;
	
	elemap::const_iterator i, j;
	
	for(i=elems.begin(), j=tmp.elems.begin();
	    i!=elems.end();
	    ++i, ++j)
	{
		if(i->second < j->second)return true;
		if(i->second > j->second)return false;
		if(i->first < j->first)return true;
	}
	return false;
}

void summa::Yksmuu(class Yksikkomuunnokset &)
{
}

elemp summa::Expand()
{
	elemap::iterator i, eka = elems.begin();
retry:
	if(elems.size() == 1 && lisays == 0)
	{
		elemap::iterator j = elems.begin();
		if(j->second == 1)
		{
			return j->first->Expand();
		}
	}
	for(i=eka; i!=elems.end(); ++i)
	{
		if(i->first->type == '+')
		{
			summap j = (summa *)&*i->first;
			elems.erase(i);
			lisays += j->lisays;
			for(elemap::iterator k = j->elems.begin();
			                     k!= j->elems.end();
			                     ++k)
			{
			    elems[k->first] += k->second;
			}
			/* Jumping out of this scope uninitializes j,
			 * and causes the pointer to be deallocated.
			 */
			eka = elems.begin();
			goto retry;
		}
		if(i->second == 0)
		{
			eka = i;
			elems.erase(i);
			goto retry;
		}
	}
	elemap nmap;
	for(i=elems.begin(); i!=elems.end(); ++i)
		nmap[i->first->Expand()] += i->second;
	if(elems != nmap)
	{
		elems = nmap;
		goto retry;
	}
	return new summa(*this);
}
