#include "yksikot.hh"
#include "yksikko.hh"

Yksikot::Yksikot()
{
	add("m", 'm');
	add("V", 'V');
	add("J", 'J');
	add("A", 'A');
	add("W", 'W');
	add("g", 'g');
	add("l", 'l');
	add("N", 'N');
	add("K", 'K');
	add("ohm", 'O');
	add("F", 'F');
	add("H", 'H');
	add("C", 'C');
	add("s", 's');
	add("h", 'h');
}

Yksikkomuunnokset::Yksikkomuunnokset(Yksikot &Yksikot)
{
	tulop tmp;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]), 1);
	tmp->insert(new yksikko(Yksikot["A"]), 1);
	tmp->insert(new yksikko(Yksikot["W"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),   1);
	tmp->insert(new yksikko(Yksikot["ohm"]), 1);
	tmp->insert(new yksikko(Yksikot["V"]),  -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["W"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["g"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]), -2);
	tmp->insert(new yksikko(Yksikot["N"]), -1);
	elems[tmp] = 0.001;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  3);
	tmp->insert(new yksikko(Yksikot["l"]), -1);
	elems[tmp] = 1000;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["C"]),  1);
	tmp->insert(new yksikko(Yksikot["V"]), -1);
	tmp->insert(new yksikko(Yksikot["F"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["A"]), -1);
	tmp->insert(new yksikko(Yksikot["H"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["C"]), -1);
	elems[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["h"]), -1);
	elems[tmp] = 3600;
}
